/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin editor.

  ==============================================================================
*/

#include "PluginProcessor.h"
#include "PluginEditor.h"

//==============================================================================
MyDspOscillatorGeneratorAudioProcessorEditor::MyDspOscillatorGeneratorAudioProcessorEditor (MyDspOscillatorGeneratorAudioProcessor& p, AudioProcessorValueTreeState& vts)
    : AudioProcessorEditor (&p), valueTreeState (vts)
{
    osc1GainLabel.setText ("Gain osc1", dontSendNotification);
    osc1GainLabel.attachToComponent (&osc1GainSlider, true);
    addAndMakeVisible (osc1GainLabel);
    
    osc1FreqLabel.setText ("Freq osc1", dontSendNotification);
    osc1FreqLabel.attachToComponent (&osc1FreqSlider, true);
    addAndMakeVisible (osc1FreqLabel);
    
    getLookAndFeel().setColour (Slider::thumbColourId, Colours::red);
    addAndMakeVisible (osc1GainSlider);
    
    osc1FreqSlider.setTextValueSuffix (" Hz");
    addAndMakeVisible (osc1FreqSlider);
    
    osc1GainAttachment.reset (new SliderAttachment (valueTreeState, "osc1_gain", osc1GainSlider));
    osc1FreqAttachment.reset (new SliderAttachment (valueTreeState, "osc1_freq", osc1FreqSlider));

    
    
    osc2GainLabel.setText ("Gain osc2", dontSendNotification);
    osc2GainLabel.attachToComponent (&osc2GainSlider, true);
    addAndMakeVisible (osc2GainLabel);
    
    osc2FreqLabel.setText ("Freq osc2", dontSendNotification);
    osc2FreqLabel.attachToComponent (&osc2FreqSlider, true);
    addAndMakeVisible (osc2FreqLabel);
    
    getLookAndFeel().setColour (Slider::thumbColourId, Colours::red);
    addAndMakeVisible (osc2GainSlider);
    
    osc2FreqSlider.setTextValueSuffix (" Hz");
    addAndMakeVisible (osc2FreqSlider);
    
    osc2GainAttachment.reset (new SliderAttachment (valueTreeState, "osc2_gain", osc2GainSlider));
    osc2FreqAttachment.reset (new SliderAttachment (valueTreeState, "osc2_freq", osc2FreqSlider));
    
    
    
    globalGainLabel.setText ("Global Gain", dontSendNotification);
    globalGainLabel.attachToComponent (&globalGainSlider, true);
    addAndMakeVisible (globalGainLabel);
    
    getLookAndFeel().setColour (Slider::thumbColourId, Colours::red);
    addAndMakeVisible (globalGainSlider);
    
    globalGainAttachment.reset (new SliderAttachment (valueTreeState, "global_gain", globalGainSlider));
    
    
    
    setSize (paramSliderWidth + paramLabelWidth + 50, jmax (500, paramControlHeight * 2 + 20));

}

MyDspOscillatorGeneratorAudioProcessorEditor::~MyDspOscillatorGeneratorAudioProcessorEditor()
{
}

//==============================================================================
void MyDspOscillatorGeneratorAudioProcessorEditor::paint (Graphics& g)
{
    g.fillAll (getLookAndFeel().findColour (ResizableWindow::backgroundColourId));
}

void MyDspOscillatorGeneratorAudioProcessorEditor::resized()
{
    auto sliderLeft = paramLabelWidth + 10;
    osc1GainSlider.setBounds (sliderLeft, 20, getWidth() - sliderLeft - 10, 20);
    osc1FreqSlider.setBounds (sliderLeft, 50, getWidth() - sliderLeft - 10, 20);
    
    osc2GainSlider.setBounds (sliderLeft, 80, getWidth() - sliderLeft - 10, 20);
    osc2FreqSlider.setBounds (sliderLeft, 110, getWidth() - sliderLeft - 10, 20);
    
    globalGainSlider.setBounds (sliderLeft, 140, getWidth() - sliderLeft - 10, 20);
}
