/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin editor.

  ==============================================================================
*/

#pragma once

#include "../JuceLibraryCode/JuceHeader.h"
#include "PluginProcessor.h"

//==============================================================================

class MyDspOscillatorGeneratorAudioProcessorEditor  : public AudioProcessorEditor
{
public:
    
    enum
    {
        paramControlHeight = 40,
        paramLabelWidth    = 80,
        paramSliderWidth   = 350
    };

    typedef AudioProcessorValueTreeState::SliderAttachment SliderAttachment;
    
    
    MyDspOscillatorGeneratorAudioProcessorEditor (MyDspOscillatorGeneratorAudioProcessor& parent, AudioProcessorValueTreeState& vts);
    ~MyDspOscillatorGeneratorAudioProcessorEditor();

    //==============================================================================
    void paint (Graphics&) override;
    void resized() override;

private:
    AudioProcessorValueTreeState& valueTreeState;

    Label osc1GainLabel;
    Label osc1FreqLabel;
    Slider osc1GainSlider;
    Slider osc1FreqSlider;

    Label osc2GainLabel;
    Label osc2FreqLabel;
    Slider osc2GainSlider;
    Slider osc2FreqSlider;
    
    Label globalGainLabel;
    Slider globalGainSlider;

    std::unique_ptr<SliderAttachment> osc1GainAttachment;
    std::unique_ptr<SliderAttachment> osc1FreqAttachment;
    
    std::unique_ptr<SliderAttachment> osc2GainAttachment;
    std::unique_ptr<SliderAttachment> osc2FreqAttachment;
    
    std::unique_ptr<SliderAttachment> globalGainAttachment;
    

    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (MyDspOscillatorGeneratorAudioProcessorEditor)
};
