/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin processor.

  ==============================================================================
*/

#pragma once

#include "../JuceLibraryCode/JuceHeader.h"
#include "MyCustomDspOscillator.h"

//==============================================================================
/**
*/
class MyDspOscillatorGeneratorAudioProcessor  : public AudioProcessor
{
public:
    //==============================================================================
    MyDspOscillatorGeneratorAudioProcessor();
    ~MyDspOscillatorGeneratorAudioProcessor();

    //==============================================================================
    void prepareToPlay (double sampleRate, int samplesPerBlock) override;
    void releaseResources() override;

   #ifndef JucePlugin_PreferredChannelConfigurations
    bool isBusesLayoutSupported (const BusesLayout& layouts) const override;
   #endif

    void processBlock (AudioBuffer<float>&, MidiBuffer&) override;

    //==============================================================================
    AudioProcessorEditor* createEditor() override;
    bool hasEditor() const override;

    //==============================================================================
    const String getName() const override;

    bool acceptsMidi() const override;
    bool producesMidi() const override;
    bool isMidiEffect() const override;
    double getTailLengthSeconds() const override;

    //==============================================================================
    int getNumPrograms() override;
    int getCurrentProgram() override;
    void setCurrentProgram (int index) override;
    const String getProgramName (int index) override;
    void changeProgramName (int index, const String& newName) override;

    //==============================================================================
    void getStateInformation (MemoryBlock& destData) override;
    void setStateInformation (const void* data, int sizeInBytes) override;

    //==============================================================================
    void updateParameters();
    void process(dsp::ProcessContextReplacing<float> context);
    void reset() override;
    
private:
    //==============================================================================
    
    AudioProcessorValueTreeState parameters;
    
    std::atomic<float>* osc1GainParameter  = nullptr;
    std::atomic<float>* osc1FreqParameter = nullptr;
    std::atomic<float>* osc2GainParameter  = nullptr;
    std::atomic<float>* osc2FreqParameter = nullptr;
    std::atomic<float>* globalGainParameter  = nullptr;
    
    enum
    {
        osc1Index,
        osc2Index,
        masterGainIndex
    };

    juce::dsp::ProcessorChain<MyCustomDspOscillator<float>, MyCustomDspOscillator<float>, juce::dsp::Gain<float>> processorChain;
    
    //==============================================================================
    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (MyDspOscillatorGeneratorAudioProcessor)
};
